﻿Imports System
Imports System.Collections.Generic

Namespace SamuraiApp.Domain
    Public Class Samurai

        Public Sub New()
            Quotes = New List(Of Quote)
            SecretIdentity = PersonName.Empty
        End Sub

        Public Property Id As Integer
        Public Property Name As String
        Public Property Quotes As List(Of Quote)

#Region "demonstrates private 1:1 prop with no backing field, note mapping in context file"
        Private Property Entrance As Entrance
        Public Sub CreateEntrance(ByVal minute As Integer, ByVal sceneName As String, ByVal description As String)
            Entrance = New Entrance(minute, sceneName, description)
        End Sub
        Public EntranceScene As String = Entrance?.SceneName

#End Region

#Region "demonstrates private 1:1 prop with backing field, note mapping in context file"
        Private _entranceWithField As EntranceWithField
        Private ReadOnly Property EntranceWithField As EntranceWithField
            Get
                Return _entranceWithField
            End Get
        End Property
        Public Sub CreateEntranceWithField(ByVal minute As Integer, ByVal sceneName As String, ByVal description As String)
            _entranceWithField = New EntranceWithField(minute, sceneName, description)
        End Sub
        Public EntranceWithFieldScene As String = _entranceWithField?.SceneName

#End Region
#Region "demonstrates use of encapsulated value object, mapped in context as Owned Entity"
        Private Property SecretIdentity As PersonName
        Public Property SamuraiSecretIdentity As Object

        Public Function RevealSecretIdentity() As String
            If SecretIdentity.IsEmpty() Then
                Return "It's a secret"
            Else
                Return SamuraiSecretIdentity.FullName()
            End If
        End Function
        Public Sub Identify(ByVal first As String, ByVal last As String)
            SecretIdentity = PersonName.Create(first, last)
        End Sub
#End Region
    End Class
End Namespace