﻿'INSTANT VB NOTE: This code snippet uses implicit typing. You will need to set 'Option Infer On' in the VB file or set 'Option Infer' at the project level.

Imports Data_Points_0917_EFCore2Model.SamuraiApp.Data
Imports Data_Points_0917_EFCore2Model.SamuraiApp.Domain
Imports Microsoft.EntityFrameworkCore

Namespace Data_Points_0917_EFCore2Model
    Friend Class Program
        Shared Sub Main(ByVal args() As String)
            Using context = New SamuraiContext
                context.Database.EnsureDeleted()
                context.Database.EnsureCreated()
            End Using
            StoreNewSamuraiWithEntrance()
            StoreNewSamuraiWithEntranceAndIdentity()
            ListSamuraisWithEntranceAndIdentity()
            Using context = New SamuraiContext
                context.Database.EnsureDeleted()
                context.Database.EnsureCreated()
            End Using
            Console.WriteLine("--- Now with EntranceBackingField")
            StoreNewSamuraiWithEntranceBacking()
            StoreNewSamuraiWithEntranceBackingAndIdentity()
            ListSamuraisWithEntranceBackingAndIdentity()
        End Sub
        Private Shared Sub StoreNewSamuraiWithEntrance()
            Dim samurai = New Samurai With {.Name = "Julie"}

            samurai.CreateEntrance(1, "S1", "Here I am!")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub

        Private Shared Sub StoreNewSamuraiWithEntranceAndIdentity()
            Dim samurai = New Samurai With {.Name = "Giantpuppy"}
            samurai.Identify("Sampson", "Newfie")
            samurai.CreateEntrance(2, "S2", "Woof!")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub
        Private Shared Sub ListSamuraisWithEntranceAndIdentity()
            Using context = New SamuraiContext
                Dim samurais = context.Samurais.Include("Entrance").ToList()
                For Each samurai In samurais
                    Console.WriteLine($"{samurai.Name}, Enters in {samurai.EntranceScene} ")
                    Console.WriteLine($"Secret Identity: {samurai.RevealSecretIdentity()}")

                Next samurai
            End Using
        End Sub
        Private Shared Sub StoreNewSamuraiWithEntranceBacking()
            Dim samurai = New Samurai With {.Name = "Julie_B"}

            samurai.CreateEntranceWithField(1, "S1B", "Here I am again!")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub

        Private Shared Sub StoreNewSamuraiWithEntranceBackingAndIdentity()
            Dim samurai = New Samurai With {.Name = "Giantpuppy_B"}
            samurai.Identify("Sampson", "Newfie")
            samurai.CreateEntranceWithField(2, "S2B", "Woof! Woof!")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub
        Private Shared Sub ListSamuraisWithEntranceBackingAndIdentity()
            Using context = New SamuraiContext
                Dim samurais = context.Samurais.Include("EntranceWithField").ToList()
                For Each samurai In samurais
                    Console.WriteLine($"{samurai.Name}, Enters in {samurai.EntranceWithFieldScene} ")
                    Console.WriteLine($"Secret Identity: {samurai.RevealSecretIdentity()}")

                Next samurai
            End Using
        End Sub
    End Class
End Namespace